import csv
import torch as t
import random
import numpy as np
import pandas as pd
import scipy.sparse as sp
import os 
from RWR import rwr
from sklearn.preprocessing import PolynomialFeatures
from sklearn import metrics


def read_csv(name):
    data = pd.read_csv(name,header = None)
    data = np.array(data)
    return data
def import_data(data_path,sim_type):
    
    
    didi_matrix = read_csv(data_path + '/disease_sim.csv')
    mimi_matrix = read_csv(data_path + '/mirna_func.csv')

    # seqseq_matrix = read_csv(data_path + '/miRNA_sequence_sim.csv')
    ben_ind_label =   read_csv(data_path + '/miRNA_localization.csv')

    # didi_matrix = read_csv(data_path + '/disease_sim.csv')

    # mimi_matrix = read_csv(data_path + '/mirna_func.csv')

    dimi_matrix = read_csv(data_path + '/miRNA_disease.csv')

    smith_waterman_gip_miRNAsim = read_csv(data_path + '/smith_waterman_gip_miRNAsim.csv')
    
    # print("miRNA_sequence_sim shape ",seqseq_matrix.shape)
    print("miRNA_localiztion shape ",ben_ind_label.shape)
    print("disease_gip shape ",didi_matrix.shape)
    print("mirna_gip shape ",mimi_matrix.shape)
    print("miRNA_disease shape ",dimi_matrix.shape)
    print("smith_waterman_gip_miRNAsim shape ",smith_waterman_gip_miRNAsim.shape)

    return didi_matrix,mimi_matrix,dimi_matrix,ben_ind_label,smith_waterman_gip_miRNAsim,didi_matrix.shape[0],mimi_matrix.shape[0]

########k折划分############        
def get_k_fold_node_data(k, i,index):  
    train_mask = t.ones(len(index), dtype=t.bool) 
    test_mask = t.zeros(len(index), dtype=t.bool) 
    fold_size = len(index) // k 

    for j in range(i*fold_size,(i+1)*fold_size):
        # get train mask and test mask
        # print(index[j],end=',')
        train_mask[index[j]] = False
        test_mask[index[j]] = True
    return  train_mask,test_mask


def get_score(y_test, preds):

    auc_score = metrics.roc_auc_score(y_test, preds, average=None)

    aupr_score = metrics.average_precision_score(y_test, preds,average=None)

    return auc_score, aupr_score


def DataLoader(data_path):
    seqseq_matrix,didi_matrix,mimi_matrix,dimi_matrix,ben_ind_label,n_didi,n_mimi = import_data(data_path)
    index = [i for i  in range(n_mimi)]
    random.shuffle(index)
    device = t.device('cuda' if t.cuda.is_available() else 'cpu')
    # extract piRNA features by Random Walk with Restart
    _pi_features = rwr(seqseq_matrix, 0.8)
    poly_dis = PolynomialFeatures(2, include_bias=False)
    pi_features = poly_dis.fit_transform(_pi_features)
    print(pi_features.shape)
    # extract disease features by Random Walk with Restart and raise dimension by PolynomialFeatures
    _dis_features = rwr(didi_matrix, 0.7)
    poly_dis = PolynomialFeatures(2, include_bias=False)
    dis_features = poly_dis.fit_transform(_dis_features)
    print(dis_features.shape)
    filename = str(opt.validation) +'-fold-score'
    for i in range(opt.validation):
        print('Running {} fold ...'.format(i+1))
        train_mask,test_mask = get_k_fold_node_data(opt.validation, i,index)
        train_data = {
        "pi_feature": t.FloatTensor(pi_features).to(device),
        "dis_feature": t.FloatTensor(dis_features).to(device),
        "pi_sim": t.FloatTensor(seqseq_matrix).to(device),
        "dis_sim": t.FloatTensor(didi_matrix).to(device),
        "train_label": train_mask.to(device),
        "relation": t.FloatTensor(dimi_matrix).to(device),
        "test_label": test_mask.to(device),

        }
